####################################################################################
###
### PLOTING TREES FOR BEST SHAPES
###
###########         SYMETRIC
load("SBep.RData")
library(colorRamps)
pdf("PLEASENAMETHEPLOT-SY.pdf", family="Helvetica", height=4, width=3.50394) #ideal 3.50394 or 7.20472
palette(matlab.like2(11))
marmain=c(0,2.5,0,0)
marhist=c(0,0,1.5,0)
ysubplot=950
sizesubplot=c(0.5,0.5)
cex.axissubplot=0.7
barplotylim=c(0,600)
par(mfrow=c(3,1), mar=marmain, oma=c(2.5,0,1.2,0), cex=0.7, mgp=c(1.5,0.2,0),  tck = -0.02)
nf <- layout(matrix(c(1:6),3,2,byrow = TRUE), c(6,1), TRUE)
############   A
y<-ep$sackin
x<-ep$realleaves
plot(jitter(x), y, ylab="Sackin statistic", pch=16, cex=0.5, log="xy", col=(ep$BSsysackinmedian*10)+1, xaxt="n", bty="n") #, cex.axis=0.8, tck = -0.02
axis(side = 1, labels = FALSE, tck = -0.01)
legend("topleft", legend=c("0.1 approx. PDA",((2:9)/10),"1 Yule"), pch=rep(15,11), cex=c(0.8), col=c(1:10), bty="n", y.intersp=0.7)
mtext(" a", side=3, adj=0, font=2, cex=0.8)
par(mar=marhist)
barplot(table(ep$BSsysackinmedian), col=c(1:11), xaxt="n", ylim=barplotylim)
text(4.5, table(ep$BSsysackinmedian)[4]+20, "*") #median 0.4
text(3, table(ep$BSsysackinmedian)[3]+20, "x", cex=0.6) #least.square.shape 0.3
par(mar=marmain)
############   B
y<-ep$colless
x<-ep$realleaves
plot(jitter(x), y, ylab= "Colless statistic", pch=16, cex=0.5, log="xy", col=(ep$BSsycollessmedian*10)+1, xaxt="n", bty="n") #, cex.axis=0.8, tck = -0.02
axis(side = 1, labels = FALSE, tck = -0.01)
mtext(" b", side=3, adj=0, font=2, line=-1.5, cex=0.8)
par(mar=marhist)
barplot(table(ep$BSsycollessmedian), col=c(1:11), xaxt="n", ylim=barplotylim)
text(4.5, table(ep$BSsycollessmedian)[4]+20, "*") #median 0.4
text(3, table(ep$BSsycollessmedian)[3]+20, "x", cex=0.6) #least.square.shape 0.3
par(mar=marmain)
############   C
y<-ep$maxlik.betasplit
x<-ep$realleaves
plot(jitter(x), y, xlab="Tips", ylab = expression( paste(beta, " statistic")),  pch=16, cex=0.5, log="x", col=(ep$BSsybetamedian*10)+1,ylim=c(-2,2), bty="n", xaxt="n", mgp=c(1.3,0.2,0)) #, cex.axis=0.8, tck = -0.02
axis(side = 1, labels = TRUE, tck = -0.01) #, cex.axis=0.8
mtext("                                                          Tip                                   Counts", side=1, line=1.4, outer=TRUE, cex=0.7)
mtext(" c", side=3, adj=0, font=2, line=-1.3, cex=0.8)
par(mar=marhist)
barplot(table(ep$BSsybetamedian), col=c(1:11), xaxt="n", ylim=barplotylim)
text(5.5, table(ep$BSsybetamedian)[5]+20, "*") # median 0.5
text(8,table(ep$BSsybetamedian)[7]+20,"x", cex=0.6) #least.square.shape 0.7
par(mar=marmain)
dev.off()
###########        FOR ASYMETRIC
load("SBep.RData")
library(colorRamps)
pdf("PLEASENAMETHEPLOT-ASY.pdf", family="Helvetica", height=4, width=3.50394) #ideal 3.50394 or 7.20472
palette(matlab.like2(11))
marmain=c(0,2.5,0,0)
marhist=c(0,0,1.5,0)
ysubplot=950
sizesubplot=c(0.5,0.5)
cex.axissubplot=0.7
barplotylim=c(0,600)
par(mfrow=c(3,1), mar=marmain, oma=c(2.5,0,1.2,0), cex=0.7, mgp=c(1.5,0.2,0),  tck = -0.02)
nf <- layout(matrix(c(1:6),3,2,byrow = TRUE), c(6,1), TRUE)
############   A
y<-ep$sackin
x<-ep$realleaves
plot(jitter(x), y, ylab="Sackin statistic", pch=16, cex=0.5, log="xy", col=(ep$BSasysackinmedian*10)+1, xaxt="n", bty="n") #, cex.axis=0.8, tck = -0.02
axis(side = 1, labels = FALSE, tck = -0.01)
legend("topleft", legend=c("0.1 approx. PDA",((2:9)/10),"1 Yule"), pch=rep(15,11), cex=c(0.8), col=c(1:10), bty="n", y.intersp=0.7)
mtext(" a", side=3, adj=0, font=2, cex=0.8)
par(mar=marhist)
barplot(table(ep$BSasysackinmedian), col=c(1:11), xaxt="n", ylim=barplotylim)
text(4.5, table(ep$BSasysackinmedian)[4]+20, "*") #median 0.4
text(3, table(ep$BSasysackinmedian)[3]+20, "x", cex=0.6) #least.square.shape 0.3
par(mar=marmain)
############   B
y<-ep$colless
x<-ep$realleaves
plot(jitter(x), y, ylab= "Colless statistic", pch=16, cex=0.5, log="xy", col=(ep$BSasycollessmedian*10)+1, xaxt="n", bty="n") #, cex.axis=0.8, tck = -0.02
axis(side = 1, labels = FALSE, tck = -0.01)
mtext(" b", side=3, adj=0, font=2, line=-1.5, cex=0.8)
par(mar=marhist)
barplot(table(ep$BSasycollessmedian), col=c(1:11), xaxt="n", ylim=barplotylim)
text(5.5, table(ep$BSasycollessmedian)[5]+20, "*") #median 0.5
text(3, table(ep$BSasycollessmedian)[3]+20, "x", cex=0.6) #least.square.shape 0.3
par(mar=marmain)
############   C
y<-ep$maxlik.betasplit
x<-ep$realleaves
plot(jitter(x), y, xlab="Tips", ylab = expression( paste(beta, " statistic")),  pch=16, cex=0.5, log="x", col=(ep$BSasybetamedian*10)+1,ylim=c(-2,2), bty="n", xaxt="n", mgp=c(1.3,0.2,0)) #, cex.axis=0.8, tck = -0.02
axis(side = 1, labels = TRUE, tck = -0.01) #, cex.axis=0.8
mtext("                                                          Tip                                   Counts", side=1, line=1.4, outer=TRUE, cex=0.7)
mtext(" c", side=3, adj=0, font=2, line=-1.3, cex=0.8)
par(mar=marhist)
#subplot( barplot(table(ep$BSasybetamedian), col=c(1:11), xaxt="n", ylim=c(0,580), cex.axis=cex.axissubplot), ysubplot,1, size=sizesubplot)
barplot(table(ep$BSasybetamedian), col=c(1:11), xaxt="n", ylim=barplotylim)
text(5.5, table(ep$BSasybetamedian)[5]+20, "*") # median 0.5
text(8,table(ep$BSasybetamedian)[7]+20,"x", cex=0.6) #least.square.shape 0.7
par(mar=marmain)
dev.off()