#######
# First we create a table with the medians for the specific 
# statistic and speciation mode (cluster-simulated) using the TreeSimGM R-package
# to them fit with a linnear equation.
#

#load here SBFUSED.RData (input data that contains the simulated trees under distinct parameters)

#
## start loop for BETA Statistics ###
#
#create shapeVs.tip SY beta median table
SBsybetamedian <- matrix(NA, ncol=11, nrow=9, dimnames=list(c(1:9),c("n","0.1","0.2","0.3","0.4","0.5","0.6","0.7","0.8","0.9","1")))
SBsybetamedian[,1] <- c(5,10,20,50,100,200,500,1000,2000)
for (iN in 1:length(SBsybetamedian[,1])){
  for (iS in 1:10){
    print(paste("iN=",SBsybetamedian[iN,1]," iS=",iS/10))
    SBsybetamedian[iN,iS+1] <- median(ABC$sy$maxlik.betasplit[ABC$parameter$n==SBsybetamedian[iN,1] & ABC$parameter$shape==(iS/10)])
  }  
}
SBsybetamedian
#create shapeVs.tip ASY beta median table
SBasybetamedian <- matrix(NA, ncol=11, nrow=9, dimnames=list(c(1:9),c("n","0.1","0.2","0.3","0.4","0.5","0.6","0.7","0.8","0.9","1")))
SBasybetamedian[,1] <- c(5,10,20,50,100,200,500,1000,2000)
for (iN in 1:length(SBasybetamedian[,1])){
  for (iS in 1:10){
    print(paste("iN=",SBasybetamedian[iN,1]," iS=",iS/10))
    SBasybetamedian[iN,iS+1] <- median(ABC$asy$maxlik.betasplit[ABC$parameter$n==SBasybetamedian[iN,1] & ABC$parameter$shape==(iS/10)])
  }  
}
SBasybetamedian
#
## start loop for COLLESS Statistics ###
#
#create shapeVs.tip SY colless median table
SBsycollessmedian <- matrix(NA, ncol=11, nrow=9, dimnames=list(c(1:9),c("n","0.1","0.2","0.3","0.4","0.5","0.6","0.7","0.8","0.9","1")))
SBsycollessmedian[,1] <- c(5,10,20,50,100,200,500,1000,2000)
for (iN in 1:length(SBsycollessmedian[,1])){
  for (iS in 1:10){
    print(paste("iN=",SBsycollessmedian[iN,1]," iS=",iS/10))
    SBsycollessmedian[iN,iS+1] <- median(ABC$sy$colless[ABC$parameter$n==SBsycollessmedian[iN,1] & ABC$parameter$shape==(iS/10)])
  }  
}
SBsycollessmedian
#create shapeVs.tip ASY colless median table
SBasycollessmedian <- matrix(NA, ncol=11, nrow=9, dimnames=list(c(1:9),c("n","0.1","0.2","0.3","0.4","0.5","0.6","0.7","0.8","0.9","1")))
SBasycollessmedian[,1] <- c(5,10,20,50,100,200,500,1000,2000)
for (iN in 1:length(SBasycollessmedian[,1])){
  for (iS in 1:10){
    print(paste("iN=",SBasycollessmedian[iN,1]," iS=",iS/10))
    SBasycollessmedian[iN,iS+1] <- median(ABC$asy$colless[ABC$parameter$n==SBasycollessmedian[iN,1] & ABC$parameter$shape==(iS/10)])
  }  
}
SBasycollessmedian
#
## start loop for SACKIN Statistics ###
#
#create shapeVs.tip SY sackin median table
SBsysackinmedian <- matrix(NA, ncol=11, nrow=9, dimnames=list(c(1:9),c("n","0.1","0.2","0.3","0.4","0.5","0.6","0.7","0.8","0.9","1")))
SBsysackinmedian[,1] <- c(5,10,20,50,100,200,500,1000,2000)
for (iN in 1:length(SBsysackinmedian[,1])){
  for (iS in 1:10){
    print(paste("iN=",SBsysackinmedian[iN,1]," iS=",iS/10))
    SBsysackinmedian[iN,iS+1] <- median(ABC$sy$sackin[ABC$parameter$n==SBsysackinmedian[iN,1] & ABC$parameter$shape==(iS/10)])
  }  
}
SBsysackinmedian
#create shapeVs.tip ASY sackin median table
SBasysackinmedian <- matrix(NA, ncol=11, nrow=9, dimnames=list(c(1:9),c("n","0.1","0.2","0.3","0.4","0.5","0.6","0.7","0.8","0.9","1")))
SBasysackinmedian[,1] <- c(5,10,20,50,100,200,500,1000,2000)
for (iN in 1:length(SBasysackinmedian[,1])){
  for (iS in 1:10){
    print(paste("iN=",SBasysackinmedian[iN,1]," iS=",iS/10))
    SBasysackinmedian[iN,iS+1] <- median(ABC$asy$sackin[ABC$parameter$n==SBasysackinmedian[iN,1] & ABC$parameter$shape==(iS/10)])
  }  
}
SBasysackinmedian

#######
# Now, In order to have a proxy for the median tree shape statistics 
# of tree sizes which were not simulated, we do a linear interpolation 
# between the simulated median tree shape statistics for each speciation 
# mode and Φs
#

#load here the output from the treated and cached empirical trees (treebase_output.RData)

ep  <- treebaselist

#
## start loop for BETA Statistics ###
#
# for SY
ep$BSsybetamedian  <- rep(NA,length(ep$Nnode))
data <- SBsybetamedian #
tocompare <- ep$maxlik.betasplit
for (iEP in 1:length(ep$Nnode)){
  modelshapes <- rep(NA,10)
  n <- ep$Nnode[iEP]+1
  for (iS in 1:10){
    model <- approxfun(x=data[,1],y=data[,iS+1])
    if (n<5) (n=5)
    if (n>2000) (n=2000)
    modelshapes[iS] <- model(n)
  }
  ep$BSsybetamedian[iEP] <-  which.min(abs(modelshapes-tocompare[iEP]))/10
}
# for ASY
ep$BSasybetamedian  <- rep(NA,length(ep$Nnode))
data <- SBasybetamedian #
tocompare <- ep$maxlik.betasplit
for (iEP in 1:length(ep$Nnode)){
  modelshapes <- rep(NA,10)
  n <- ep$Nnode[iEP]+1
  for (iS in 1:10){
    model <- approxfun(x=data[,1],y=data[,iS+1])
    if (n<5) (n=5)
    if (n>2000) (n=2000)
    modelshapes[iS] <- model(n)
  }
  ep$BSasybetamedian[iEP] <-  which.min(abs(modelshapes-tocompare[iEP]))/10
}
#
## start loop for COLLESS Statistics ###
#
# for SY
ep$BSsycollessmedian  <- rep(NA,length(ep$Nnode))
data <- SBsycollessmedian #
tocompare <- ep$colless
for (iEP in 1:length(ep$Nnode)){
  modelshapes <- rep(NA,10)
  n <- ep$Nnode[iEP]+1
  for (iS in 1:10){
    model <- approxfun(x=data[,1],y=data[,iS+1])
    if (n<5) (n=5)
    if (n>2000) (n=2000)
    modelshapes[iS] <- model(n)
  }
  ep$BSsycollessmedian[iEP] <-  which.min(abs(modelshapes-tocompare[iEP]))/10
}
# for ASY
ep$BSasycollessmedian  <- rep(NA,length(ep$Nnode))
data <- SBasycollessmedian #
tocompare <- ep$colless
for (iEP in 1:length(ep$Nnode)){
  modelshapes <- rep(NA,10)
  n <- ep$Nnode[iEP]+1
  for (iS in 1:10){
    model <- approxfun(x=data[,1],y=data[,iS+1])
    if (n<5) (n=5)
    if (n>2000) (n=2000)
    modelshapes[iS] <- model(n)
  }
  ep$BSasycollessmedian[iEP] <-  which.min(abs(modelshapes-tocompare[iEP]))/10
}
#
## start loop for SACKIN Statistics ###
#
# for SY
ep$BSsysackinmedian  <- rep(NA,length(ep$Nnode))
data <- SBsysackinmedian #
tocompare <- ep$sackin
for (iEP in 1:length(ep$Nnode)){
  modelshapes <- rep(NA,10)
  n <- ep$Nnode[iEP]+1
  for (iS in 1:10){
    model <- approxfun(x=data[,1],y=data[,iS+1])
    if (n<5) (n=5)
    if (n>2000) (n=2000)
    modelshapes[iS] <- model(n)
  }
  ep$BSsysackinmedian[iEP] <-  which.min(abs(modelshapes-tocompare[iEP]))/10
}
# for ASY
ep$BSasysackinmedian  <- rep(NA,length(ep$Nnode))
data <- SBasysackinmedian #
tocompare <- ep$sackin
for (iEP in 1:length(ep$Nnode)){
  modelshapes <- rep(NA,10)
  n <- ep$Nnode[iEP]+1
  for (iS in 1:10){
    model <- approxfun(x=data[,1],y=data[,iS+1])
    if (n<5) (n=5)
    if (n>2000) (n=2000)
    modelshapes[iS] <- model(n)
  }
  ep$BSasysackinmedian[iEP] <-  which.min(abs(modelshapes-tocompare[iEP]))/10
}
# At this point, it is a good idea to save your work...
# define directory and save
save(SBsybetamedian, SBsycollessmedian, SBsysackinmedian,SBasybetamedian, SBasycollessmedian, SBasysackinmedian, file="SBshapematrixes.RData")
save(ep, file="SBep.RData")

#######
# We are almoust there, now lets do the least square shape estimates...
#

# if you are not going through the script on the same day and are starting from here
# please dont forget to load "SBshapematrixes.RData" (with the stored medians from simulated data
# and also the tree on "SBep.RData"

#preparing matrix for the least.square.shape.estimate values
least.square  <- matrix(0, ncol=10, nrow=6, dimnames=list(c("beta.sy","beta.asy","colless.sy","colless.asy","sackin.sy","sackin.asy"),c("0.1","0.2","0.3","0.4","0.5","0.6","0.7","0.8","0.9","1")))
#
## start loop for BETA Statistics ###
#
# for SY
data <- SBsybetamedian 
tocompare <- ep$maxlik.betasplit
for (iEP in 1:length(ep$Nnode)){
  isquare <- rep(NA,10)
  n <- ep$Nnode[iEP]+1
  for (iS in 1:10){
    model <- approxfun(x=data[,1],y=data[,iS+1])
    if (n<5) (n=5)
    if (n>2000) (n=2000)
    isquare[iS] <- model(n)
  }
  least.square["beta.sy",] <-  least.square["beta.sy",] + (tocompare[iEP]-isquare)^2
}
# for ASY
data <- SBasybetamedian 
tocompare <- ep$maxlik.betasplit
for (iEP in 1:length(ep$Nnode)){
  isquare <- rep(NA,10)
  n <- ep$Nnode[iEP]+1
  for (iS in 1:10){
    model <- approxfun(x=data[,1],y=data[,iS+1])
    if (n<5) (n=5)
    if (n>2000) (n=2000)
    isquare[iS] <- model(n)
  }
  least.square["beta.asy",] <-  least.square["beta.asy",] + (tocompare[iEP]-isquare)^2
}
#
## start loop for COLLESS Statistics ###
#
# for SY
data <- SBsycollessmedian
tocompare <- ep$colless
for (iEP in 1:length(ep$Nnode)){
  isquare <- rep(NA,10)
  n <- ep$Nnode[iEP]+1
  for (iS in 1:10){
    model <- approxfun(x=data[,1],y=data[,iS+1])
    if (n<5) (n=5)
    if (n>2000) (n=2000)
    isquare[iS] <- model(n)
  }
  least.square["colless.sy",] <-  least.square["colless.sy",] + ((tocompare[iEP]-isquare)/isquare)^2
}
# for ASY
data <- SBasycollessmedian
tocompare <- ep$colless
for (iEP in 1:length(ep$Nnode)){
  isquare <- rep(NA,10)
  n <- ep$Nnode[iEP]+1
  for (iS in 1:10){
    model <- approxfun(x=data[,1],y=data[,iS+1])
    if (n<5) (n=5)
    if (n>2000) (n=2000)
    isquare[iS] <- model(n)
  }
  least.square["colless.asy",] <-  least.square["colless.asy",] +((tocompare[iEP]-isquare)/isquare)^2
}
#
## start loop for SACKIN Statistics ###
#
# for SY
data <- SBsysackinmedian
tocompare <- ep$sackin
for (iEP in 1:length(ep$Nnode)){
  isquare <- rep(NA,10)
  n <- ep$Nnode[iEP]+1
  for (iS in 1:10){
    model <- approxfun(x=data[,1],y=data[,iS+1])
    if (n<5) (n=5)
    if (n>2000) (n=2000)
    isquare[iS] <- model(n)
  }
  least.square["sackin.sy",] <-  least.square["sackin.sy",] + ((tocompare[iEP]-isquare)/isquare)^2
}
# for ASY
data <- SBasysackinmedian
tocompare <- ep$sackin
for (iEP in 1:length(ep$Nnode)){
  isquare <- rep(NA,10)
  n <- ep$Nnode[iEP]+1
  for (iS in 1:10){
    model <- approxfun(x=data[,1],y=data[,iS+1])
    if (n<5) (n=5)
    if (n>2000) (n=2000)
    isquare[iS] <- model(n)
  }
  least.square["sackin.asy",] <-  least.square["sackin.asy",] + ((tocompare[iEP]-isquare)/isquare)^2
}

#finding the minimum.....
least.square.shape.min <- matrix(NA, ncol=6, nrow=1, dimnames=list("best.shape",dimnames(least.square)[[1]]))
for (i in 1:6){
  least.square.shape.min[i]  <- which.min(least.square[i,])/10
}
# Now lets save our results
save(least.square,least.square.shape.min, file="SBleast.square.RData")